#!/usr/bin/perl
#$cgi_path = "/path/to/cgi-bin";

eval {
  use Time::Local;

  if($cgi_path eq '') {
    $cgi_path = `pwd`;
    $cgi_path =~ s/[[:space:]\r\n]//g;
    if($cgi_path eq '') {
      $cgi_path = `cd`;
      $cgi_path =~ s/[[:space:]\r\n]//g;
      if($cgi_path eq '') {
        derr("Es ist ntig das Sie bei \$cgi_path in Zeile 2 der Scripte eine korrekte Angabe machen.\n");
      }
    }
  }
  
  require "./functions.pl";
  require "./ccodes.pl";
  if(-e "$cgi_path/data/options.pl") {
    require "$cgi_path/data/options.pl";
  } else {
    err("Bitte fhren Sie die setup.cgi aus um pStats zu konfigurieren (options.pl nicht gefunden)", 1);
  }

  $color[0] = "#006000";
  $color[1] = "#000000";
  $images = $OPTION{'image_path'};

  $script_url = "$OPTION{'cgi_url'}/viewstats.cgi";
  $script_path = "$OPTION{'cgi_path'}";

  @cookies = split(/;/, $ENV{'HTTP_COOKIE'});
  foreach(@cookies) {
    ($name, $value) = split(/=/, $_);
    $COOKIE{$name} = $value;
  }

  if($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    foreach $pair (split(/&/, $buffer))
    {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/~!/ ~!/g;
      $FORM{$name} = $value;
    }
  } else { 
    @pairs = split(/&/, $ENV{'QUERY_STRING'});
    foreach $pair (@pairs) 
    {
      ($name, $value) = split(/=/, $pair);
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/~!/ ~!/g;
      $FORM{$name} = $value;
    }
  }
  $cname = "pstats-$ENV{'HTTP_HOST'}-$FORM{'id'}";
  if(defined $FORM{'pass'}) {
    $pass = $FORM{'pass'};
  } else {
    $pass = $COOKIE{$cname};
  }

  $dpath = "$cgi_path/data/members/$FORM{'id'}/";

  open(MEMBER, "$cgi_path/data/members/$FORM{'id'}.dat") || err("Kann Mitgliederdatei nicht ffnen.", 1);
  @mem = <MEMBER>;
  close(MEMBER);

  if($mem[4] > 0) {
    chomp($mem[1]);
    $cpass = crypt($pass, "ps");
    if($cpass ne $mem[1]) {
      foreach(keys %FORM) {
        $VAR{$_} = $FORM{$_};
      }
      print "Content-Type: text/html\n\n";
      fparse('_stats_login.htmlt');
      exit;
    }
    $expr = date(time + 600);
    $domain = $ENV{'HTTP_HOST'};
    $path = $ENV{'REQUEST_URI'};
    $path =~ s/^(.*)\/.*$/$1/g;
    print "Set-Cookie: $cname=$pass; path=$path; domain=$domain;\n";
  }

  if($FORM{'eDate'} eq '') {
    ($sec, $min, $hour, $mday, $cmon, $cyear, $wday, $yday, $isdst) = localtime(time);
    $cmon += 1;
    $cyear += 1900;
  } else {
    ($cmon, $mday, $cyear) = split(/-/, $FORM{'eDate'});
  }
  $today = "$cmon-$mday-$cyear";

  if($FORM{'user'} eq '') { $FORM{'user'} = ".*"; }
  if($FORM{'loc'} eq '') { $FORM{'loc'} = ".*"; }
  if($FORM{'ref'} eq '') { $FORM{'ref'} = ".*"; }

  if($FORM{'action'} eq '') {
    $FORM{'action'} = "summary";
  }
  *action = $FORM{'action'};
  &action();

  $ref  = $FORM{'ref'};
  $loc  = $FORM{'loc'};
  $user = $FORM{'user'};
  $yest = &GetPrevDate($today);
  $tom  = &GetNextDate($today);

  $VAR{'ID'}        = $FORM{'id'};
  $VAR{'SUMMARY'}   = "$OPTION{'cgi_url'}/viewstats.cgi?id=$FORM{'id'}&eDate=$today&ref=$ref&loc=$loc&user=$user";
  $VAR{'URLS'}      = "$OPTION{'cgi_url'}/viewstats.cgi?id=$FORM{'id'}&action=urls&eDate=$today&ref=$ref&loc=$loc&user=$user";
  $VAR{'REFERRERS'} = "$OPTION{'cgi_url'}/viewstats.cgi?id=$FORM{'id'}&action=refs&eDate=$today&loc=$loc&ref=$ref&user=$user";
  $VAR{'USERS'}     = "$OPTION{'cgi_url'}/viewstats.cgi?id=$FORM{'id'}&action=users&eDate=$today&loc=$loc&ref=$ref&user=$user";
  $VAR{'COUNTRIES'} = "$OPTION{'cgi_url'}/viewstats.cgi?id=$FORM{'id'}&action=countries&eDate=$today&loc=$loc&ref=$ref&user=$user";
  $VAR{'PREV'}      = "$OPTION{'cgi_url'}/viewstats.cgi?id=$FORM{'id'}&action=$FORM{'action'}&eDate=$yest&zoom=$FORM{'zoom'}&ref=$ref&loc=$loc&user=$user";
  $VAR{'NEXT'}      = "$OPTION{'cgi_url'}/viewstats.cgi?id=$FORM{'id'}&action=$FORM{'action'}&eDate=$tom&zoom=$FORM{'zoom'}&ref=$ref&loc=$loc&user=$user";
  $VAR{'GRAPH'}       = $graph;
  $VAR{'TABLE'}       = $table;
  $VAR{'IMAGE_URL'}   = $images;

  print "Content-Type: text/html\n\n";
  fparse('_stats.htmlt'); 
};

if ($@) {
  derr($@);
}
exit;

sub derr {
  my $msg = shift;
  print "Content-Type: text/html\n\n";
  print "<BODY><CENTER>\n";
  print "<TABLE width=75% border=0>\n";
  print "<TR><TD bgcolor=#0000FF><FONT face=Verdana size=2 color=white><B>pStats: FEHLER!</B></font></td></tr>\n";
  print "<TR><TD><FONT face=Verdana size=2 color=red>$msg</font></td></tr>\n";
  print "</table></CENTER></body>";
  exit; 
}

sub summary {
  if($FORM{'zoom'} eq 'h') { 
    unshift(@dates, $today);
    $by = "Stunde";
  } else { 
    $FORM{'zoom'} = "d";
    $x = 0; 
    $rDate = $today;
    while($x < 24) {
      $start = $rDate;
      unshift(@dates, $rDate);
      $rDate = &GetPrevDate($rDate);
      $x += 1;
    }
    $by = "Tag";
  }
  $label = "Hits";
  $sortby = 0;
  &GetData;
  &DrawLast15;
  &DrawGraph;
  &DrawBrowsers;
  &DrawResolutions;
}

sub urls {
  $label = "URL's";
  unshift(@dates, $today);
  $sortby = 1;
  $by = "URL";
  &GetData;
  &DrawLast15;
  &DrawGraph;
  &DrawTable;
  &DrawBrowsers;
  &DrawResolutions;
}

sub refs {
  $label = "Referer";
  unshift(@dates, $today);
  $sortby = 1;
  $by = "Ref";
  &GetData;
  &DrawLast15;
  &DrawGraph;
  &DrawTable;
  &DrawBrowsers;
  &DrawResolutions;
}

sub users {
  $label = "Besucher";
  unshift(@dates, $today);
  $sortby = 1;
  $by = "User";
  &GetData;
  &DrawLast15;
  &DrawGraph;
  &DrawTable;
  &DrawBrowsers;
  &DrawResolutions;
}

sub countries {
  $label = "Lnder";
  unshift(@dates, $today);
  $sortby = 1;
  $by = "Land ";
  &GetData;
  &DrawLast15;
  &DrawGraph;
  &DrawTable;
  &DrawBrowsers;
  &DrawResolutions;
}

sub GetData {
  $sDate = $eDate - $spread;
  $tempDate = $sDate;
  foreach $tempDate (@dates) {
    if($FORM{'action'} eq 'summary' && $FORM{'zoom'} eq 'd') {
      $HITS{$tempDate} = 0;
    }
    open(LOG, "$dpath/$tempDate.dat");
    while(<LOG>) {
      chomp($_);
      ($time, $user, $loc, $ref, $res, $nav) = split(/\|/, $_);
      $_ = $ref;
      if(m/$FORM{'ref'}/) {
        $_ = $loc;
        if(m/$FORM{'loc'}/) {
          $_ = $user;
          if(m/$FORM{'user'}/) {
            if ($FORM{'action'} eq 'refs') {
              $ref = "No Referer" unless($ref ne '');
              $HITS{$ref} += 1;
            } elsif ($FORM{'action'} eq 'urls') {
              $loc = "Undefined" unless($loc ne '');
              $HITS{$loc} += 1;
            } elsif ($FORM{'action'} eq 'users') {
              $user = "Unknown" unless($user ne '');
              $HITS{$user} += 1;
            } elsif ($FORM{'action'} eq 'countries') {
              @parts = split(/\./, $user);
              $country = $CCODES{uc($parts[$#parts])};
              $country = "Unknown" unless($country ne '');
              $HITS{$country} += 1;
            } else {
              if($FORM{'zoom'} eq "h") {
                $hour = (localtime($time))[2];
                $HITS{$hour} += 1;
              } else {
                $HITS{$tempDate} += 1;
              }
            }
            if(push(@LAST, "$user|$time") > 15) {
              shift @LAST;
            }
            $nav = "Unknown" unless($nav ne '');
            $NAVS{$nav} += 1;
            $res = "Unknown" unless($res ne '');
            $RESS{$res} += 1;
            $UNIQ{$user} = 1;
            $totalhits  += 1;
          }
        }
      }
    }
  }
  foreach(keys %UNIQ) {
    $VAR{'UNIQUE'} += 1;
  }
  $VAR{'TOTALHITS'} = $totalhits;
}

sub DrawGraph {
     $graph .= "<TABLE border=0 cellpadding=0 cellspacing=0 hspace=0 vspace=0>\n";
     $end = $today;
     $graph .= "<TR><TD colspan=26 align=center><FONT face=\"Verdana,Arial\" size=2>$label vom ";
     if($start ne '') {
       $graph .= "$start bis ";
     }
     $graph .= "$today</font></td></tr>\n";
     $graph .= "<TR>\n";
     $scale    = 1;
     $div      = 1;
     foreach (keys %HITS) {
       while(($scale * 100) < $HITS{$_}) { $scale += 1; }
       while(($div * 100) < $HITS{$_}) { $div *= 10; }
     }
     $max = (($scale * 100) - ($scale * 10));
     if($FORM{'action'} eq "summary") {
       if($FORM{'zoom'} eq 'h') {
         $start = 0;
         $end = 24;
         $step = 1;
         while($start < $end) {
           if(!defined $HITS{$start}) { $HITS{$start} = 0; }
           $start += $step;
         }
       }
     }
     $graph .= "<TD align=\"right\" valign=\"bottom\" height=\"20\"><FONT size=1 color=\"#006000\" FACE=\"Verdana,Arial\"><B>$max</b></font></TD>\n";
     $FORM{'loc'} =~ s/([\?&=])/sprintf("%%%x", ord($1))/gise;
     $FORM{'ref'} =~ s/([\?&=])/sprintf("%%%x", ord($1))/gise;
     $count = 0;
     foreach (sort { $sortby > 0 ? $HITS{$b} <=> $HITS{$a} : &sday } keys %HITS) {
       $height = ($HITS{$_} * 2) / $scale + 1;
       if($FORM{'action'} eq 'summary' && $FORM{'zoom'} eq 'd') {
         $as = "<a href=\"$script_url?id=$FORM{'id'}&zoom=h&loc=$FORM{'loc'}&ref=$FORM{'ref'}&user=$FORM{'user'}&eDate=$_\">";
         $ae = "</a>";
       }
       $graph .= "<TD width=15 rowspan=10 background=\"$images/graph_bg.gif\" valign=\"bottom\" align=\"center\">$as<img border=0 width=\"10\" height=$height alt=\"$HITS{$_}\" src=\"$images/graph_bar.gif\">$ae</TD>\n";
       $count += 1;
       if($count >= 24) { last; }
     }
     while($count < 24) {
       $graph .= "<TD width=15 rowspan=10 background=\"$images/graph_bg.gif\" valign=\"bottom\" align=\"center\"><img border=0 width=\"10\" height=1 alt=\"0\" src=\"$images/graph_bar.gif\"></TD>\n";
       $count += 1;
     }
     $graph .= "<TD rowspan=10 align=\"right\" background=\"$images/graph_right.gif\">&nbsp;</TD>\n";
     $graph .= "</TR>\n";
     $max -= ($scale * 10);
     while($max >= 0) {
       $graph .= "<TR><TD align=\"right\" valign=\"bottom\" height=\"20\"><FONT size=1 color=\"#006000\" FACE=\"Verdana,Arial\"><B>$max</b></font></td></tr>\n";
       $max -= ($scale * 10);
     }
     $graph .= "<TR>\n";
     $graph .= "<TD align=\"right\" valign=\"bottom\"><FONT size=1 FACE=\"Verdana,Arial\">x$div</font></TD>\n";
     $c = 0;
     $count = 0;
     foreach (sort { $sortby > 0 ? $HITS{$b} <=> $HITS{$a} : &sday } keys %HITS) {
       $sHits = sprintf("%.0f", $HITS{$_} / $div);
       $graph .= "<TD align=\"center\" bgcolor=\"$color[$c]\"><FONT size=1 FACE=\"Verdana,Arial\">$sHits</font></td>\n";
       $c += 1;
       if($c > 1) { $c = 0; }
       $count += 1;
       if($count >= 24) { last; }
     }
     while($count < 24) {
       $graph .= "<TD align=\"center\" bgcolor=\"$color[$c]\"><FONT size=1 FACE=\"Verdana,Arial\">0</font></td>\n";
       $c += 1;
       if($c > 1) { $c = 0; }
       $count += 1;
     }
     $graph .= "</TR><TR>\n";
     $graph .= "<TR>\n";
     $graph .= "<TD align=\"right\" valign=\"bottom\"><FONT size=1 FACE=\"Verdana,Arial\">$by</font></TD>\n";
     $c = 0;
     $count = 0; 
     foreach (sort { $sortby > 0 ? $HITS{$b} <=> $HITS{$a} : &sday } keys %HITS) {
       if ($FORM{'action'} eq 'refs' || $FORM{'action'} eq 'urls' || $FORM{'action'} eq 'users' || $FORM{'action'} eq 'countries') {
         $date = $count;
       } else {
         if($FORM{'zoom'} eq 'h') {
           $date = $_;
         } else {
           $date = (split(/-/, $_))[1];
         }
       }
       $graph .= "<TD align=\"center\" bgcolor=\"$color[$c]\"><FONT size=1 FACE=\"Verdana,Arial\">$date</font></td>\n";
       $tempDate += $step;
       $c += 1;
       if($c > 1) { $c = 0; }
       $count += 1;
       if($count >= 24) { last; }
     }
     while($count < 24) { 
       $graph .= "<TD align=\"center\" bgcolor=\"$color[$c]\"><FONT size=1 FACE=\"Verdana,Arial\">$count</font></td>\n";
       $count += 1;
     }     
     $graph .= "</TR>\n";
     $graph .= "</TABLE>\n";
}

sub DrawTable {
     $table .= "<TABLE border=0 cellpadding=1 cellspacing=2 hspace=0 vspace=0 width=\"500\">\n";
     $table .= "<TR><TD align=\"center\" colspan=\"3\" bgcolor=\"#000040\"><FONT face=\"Verdana,Arial\" size=2>Top $label</FONT></TD></TR>\n";
     $table .= "<TR>\n";
     $table .= "<TH align=\"left\" bgcolor=\"#000040\" width =\"50\"><FONT face=\"Verdana,Arial\" size=2>Rang</FONT></TH>\n";
     $table .= "<TH align=\"center\" bgcolor=\"#000040\" width=\"100\"><FONT face=\"Verdana,Arial\" size=2>Hits</FONT></TH>\n"; 
     $table .= "<TH align=\"center\" bgcolor=\"#000040\" width=\"350\"><FONT face=\"Verdana,Arial\" size=2>$label</FONT></TH></TR>\n";
     $x = 1;
     foreach (sort { $sortby > 0 ? $HITS{$b} <=> $HITS{$a} : $a cmp $b } keys %HITS) {
          if(length($_) > 50) { 
            $url = substr($_, 0, 50);
            $url .= "...";
          } else {
            $url = "$_";
          }
          $url =~ s/>/&gt;/;
          $url =~ s/</&lt;/;
          $astart = $aend = "";
          if($FORM{'action'} eq 'refs' || $FORM{'action'} eq 'urls') {
            if($_ ne "Unknown" && $_ ne "No Referer") {
              $astart = "<a href=\"$_\">";
              $aend   = "</a>";
            }
          }
          $table .= "<TR>\n";
          $table .= "<TD align=\"right\"><FONT face=\"Verdana,Arial\" size=1>$x</FONT></TD>\n";
          $table .= "<TD align=\"right\"><FONT face=\"Verdana,Arial\" size=1>$HITS{$_}</FONT></TD>\n";
          $table .= "<TD align=\"left\"><FONT face=\"Verdana,Arial\" size=1>$astart$url$aend</FONT></TD>\n";
          $table .= "</TR>\n";
          $x += 1;
     }
     $table .= "</TABLE>\n";
}

sub DrawLast15 {
  $VAR{'LAST15'} = "";
  $html = fread('_stats_last.htmlt');
  foreach(@LAST) {
    ($VAR{'user'}, $time) = split(/\|/, $_);
    ($VAR{'sec'}, $VAR{'min'}, $VAR{'hour'}, $VAR{'mday'}, $VAR{'cmon'}, $VAR{'cyear'}, $VAR{'wday'}, $VAR{'yday'}, $VAR{'isdst'}) = localtime($time);
    $VAR{'cmon'} += 1;
    $VAR{'cyear'} += 1900;
    $VAR{'min'} = "0$VAR{'min'}" if ($VAR{'min'} < 10);
    $VAR{'hour'} = "0$VAR{'hour'}" if($VAR{'hour'} < 10);
    $temp = $html;
    $temp =~ s/#%(.*?)%#/$VAR{$1}/gise;
    $VAR{'LAST15'} .= "$temp";
  }
}

sub DrawBrowsers {
  $VAR{'BROWSERS'} .= "<TABLE border=0 width=100%>";
  $leftover = $totalhits;
  $x = 0;
  foreach(sort { $NAVS{$b} <=> $NAVS{$a} } keys %NAVS) {
    $percent = sprintf("%.0f", ($NAVS{$_} / $totalhits) * 100);
    $VAR{'BROWSERS'} .= "<TR><TD><FONT face=Arial size=1>$_<BR>$NAVS{$_} Hits - $percent\%</FONT><BR></TD></TR>";
    $leftover -= $NAVS{$_};
    $x++;
    if ($x > 4) {
      $percent = sprintf("%0.f", ($leftover / $totalhits) * 100);
      $VAR{'BROWSERS'} .= "<TR><TD><FONT face=Arial size=1>Andere<BR>$leftover - $percent\%</font></td></tr>";
      last;
    }
  }
  $VAR{'BROWSERS'} .= "</TABLE>";  
}

sub DrawResolutions {
  $VAR{'RESOLUTIONS'} .= "<TABLE border=0 width=100%>";
  $leftover = $totalhits;
  $x = 0;
  foreach(sort { $RESS{$b} <=> $RESS{$a} } keys %RESS) {
    $percent = sprintf("%.0f", ($RESS{$_} / $totalhits) * 100);
    $VAR{'RESOLUTIONS'} .= "<TR><TD><FONT face=Arial size=1>$_<BR>$RESS{$_} Hits - $percent\%</FONT><BR></TD></TR>";
    $leftover -= $RESS{$_};
    $x++;
    if ($x > 4) {
      $percent = sprintf("%0.f", ($leftover / $totalhits) * 100);
      $VAR{'RESOLUTIONS'} .= "<TR><TD><FONT face=Arial size=1>Andere<BR>$leftover - $percent\%</font></td></tr>";
      last;
    }
  }
  $VAR{'RESOLUTIONS'} .= "</TABLE>";  
}

sub _isLeapYear {
  my $y = shift;
  return 0 if ($y % 4);
  return 1 if ($y % 100);
  return 0 if ($y % 400);
  return 1;
}

sub Days_in_Month {
  my ($y, $m) = @_;
  return ('x', 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)[$m]
    unless $m == 2;
  return _isLeapYear($y) ? 29 : 28;
}

sub sday {
  if ($FORM{'zoom'} eq 'h') {
    return $a <=> $b;
  } else {
    ($mon1, $day1, $year1) = split(/-/, $a);
    ($mon2, $day2, $year2) = split(/-/, $b);
    if($year1 ne $year2) {
      return $year1 <=> $year2;
    } elsif ($mon1 ne $mon2) { 
      return $mon1 <=> $mon2; 
    } elsif ($day1 ne $day2) {
      return $day1 <=> $day2;
    }
    return $a <=> $b;
  }
}
