#!/usr/bin/perl
#$cgi_path = "/path/to/cgi-bin";

if($cgi_path eq '') {
  $cgi_path = `pwd`;
  $cgi_path =~ s/[[:space:]\r\n]//g;
  if($cgi_path eq '') {
    $cgi_path = `cd`;
    $cgi_path =~ s/[[:space:]\r\n]//g;
    if($cgi_path eq '') {
      print "Content-Type: text/html\n\n";
      print "<center>\n";
      print "You need to set \$cgi_path on line 2 of this script<BR>\n";
      print "</center>\n";
      exit;
    }
  }
}

require "$cgi_path/functions.pl";
if(-e "$cgi_path/data/options.pl") {
  require "$cgi_path/data/options.pl";
} else {
  err('Please use setup.cgi to configure pStats', 1);
}

#################
#  Script Body  #
#################

print "Content-Type: text/html\n\n";
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;
    $FORM{$name} = $value;
}

if ($FORM{'step'} == 2) {
  if($FORM{'name'} eq '') { ShowErr("please enter your name"); }
  if($FORM{'user'} eq '') { ShowErr("please enter a username"); }
  if($FORM{'email'} eq '') { ShowErr("please enter your email address"); }
  if($FORM{'site'} eq '') { ShowErr("please enter your sites url"); }
  if($FORM{'pass'} eq '') { ShowErr("please enter a password"); }
  if($FORM{'vpass'} eq '') { ShowErr("please verify your password"); }
  if(-e "$cgi_path/data/members/$FORM{'user'}.dat") {
    $user = $FORM{'user'};
    $FORM{'user'} = '';
    ShowErr("$user is already taken.");
  } else {
    if($FORM{'pass'} eq $FORM{'vpass'}) {
      if(defined $FORM{'private'}) {
        $private = 1;
      } 
      $password = crypt($FORM{'pass'}, "ps");
      $time = time;
      open(MEM, ">$cgi_path/data/members/$FORM{'user'}.dat") || ShowErr("Could not open member file for writing");
      print MEM "$FORM{'name'}\n$password\n$FORM{'email'}\n$FORM{'site'}\n$private\n$time";
      close(MEM);
      mkdir("$cgi_path/data/members/$FORM{'user'}", 0777) || ShowErr("Could not create data directory.");
    } else {
      ShowErr("Passwords do not match.");
    }
  }
  $VAR{'URL'} = "$OPTION{'cgi_url'}getjs.cgi?id=$FORM{'user'}";
  fparse('_signup_ok.htmlt');
} else {
  fparse('_signup.htmlt');
} 
exit;

sub ShowErr {
  $VAR{'MSG'}     = shift;
  $VAR{'user'}    = $FORM{'user'};
  $VAR{'email'}   = $FORM{'email'};
  $VAR{'pass'}    = $FORM{'pass'};
  $VAR{'vpass'}   = $FORM{'vpass'};
  $VAR{'private'} = $FORM{'private'};
  fparse('_signup.htmlt');
  exit;
}

