#!/usr/bin/perl
#$cgi_path = "/path/to/cgi-bin";

use Time::Local;

if($cgi_path eq '') {
  $cgi_path = `pwd`;
  $cgi_path =~ s/[[:space:]\r\n]//g;
  if($cgi_path eq '') {
    $cgi_path = `cd`;
    $cgi_path =~ s/[[:space:]\r\n]//g;
    if($cgi_path eq '') {
      print "Content-Type: text/html\n\n";
      print "<center>\n";
      print "You need to set \$cgi_path on line 2 of this script<BR>\n";
      print "</center>\n";
      exit;
    }
  }
}

require "$cgi_path/functions.pl";
if(-e "$cgi_path/data/options.pl") {
  require "$cgi_path/data/options.pl";
} else {
  err('Please use setup.cgi to configure pStats.', 1);
}

#################
# Configuration #
#################
$image          = "$OPTION{'image_path'}/$OPTION{'valid_image'}";
$invalid_image  = "$OPTION{'image_path'}/$OPTION{'invalid_image'}";
$dpath          = "$OPTION{'data_path'}";

#################
#  Script Body  #
#################

#print "Content-Type: text/html\n\n";
@pairs = split(/&/, $ENV{'QUERY_STRING'});
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;
    $value =~ s/\|/%7C/g;
    $FORM{$name} = $value;
}

if(! -e "$cgi_path/data/members/$FORM{'id'}.dat") {
  print "Location: $invalid_image\n\n";
  exit;
}

$time = time;
($sec, $min, $hour, $mday, $cmon, $cyear, $wday, $yday, $isdst) = localtime($time);
$cmon += 1;
$cyear += 1900;
$dtime = "$cmon-$mday-$cyear";
if(! -e "$cgi_path/data/members/$FORM{'id'}" || !defined $FORM{'id'}) {
  print "Location: $invalid_image\n\n";
} else {
  $addr = gethostbyaddr(pack("C4", split(/\./, $ENV{'REMOTE_ADDR'})), 2);
  $addr = $ENV{'REMOTE_ADDR'} if($addr eq '');
  open(LOG, ">>$cgi_path/data/members/$FORM{'id'}/$dtime.dat");
  print LOG "$time|$addr|$FORM{'loc'}|$FORM{'ref'}|$FORM{'res'}|$FORM{'browser'}\n"; 
  close(LOG);
  print "Location: $image\n\n";
}
exit;

