#!/usr/bin/perl
#$cgi_path = "/path/to/cgi-bin";
####################
# Global functions #
####################

if($cgi_path eq '') {
  $cgi_path = `pwd`;
  $cgi_path =~ s/[[:space:]\r\n]//g;
  if($cgi_path eq '') {
    $cgi_path = `cd`;
    $cgi_path =~ s/[[:space:]\r\n]//g;
    if($cgi_path eq '') {
      print "Content-Type: text/html\n\n";
      print "<center>\n";
      print "You need to set \$cgi_path on line 2 of this script<BR>\n";
      print "</center>\n";
      exit;
    }
  }
}

sub done {
  $VAR{'MSG'} = shift;
  fparse('_done.htmlt');
  exit;
}

sub err {
  $VAR{'ERR'} = shift;
  $header = shift;
  if($header > 0) {
    print "Content-Type: text/html\n\n";
  }
  fparse('_error.htmlt');
  exit;
}

sub fparse {
  my($page, $fh, $line) = @_;
  $fh = *STDOUT if(!$fh);
  open(FILE, "$cgi_path/templates/$page") || die "Could not open template: $page";
  while ( $line = <FILE> ) {
    $line =~ s/#%(.*?)%#/$VAR{$1}/gise;
    print $fh $line;
  }
  close(FILE);
}

sub fread {
  my $page = shift;
  open(FILE, "$cgi_path/templates/$page") || die "Could not open template: $page";
  $html = join("", <FILE>);
  close(FILE);
  return $html;
}

sub getmem {
  my $id = shift;
  $id =~ s/\..+$//;
  return $id;
}

sub _isLeapYear {
  my $y = shift;
  return 0 if ($y % 4);
  return 1 if ($y % 100);
  return 0 if ($y % 400);
  return 1;
}

sub Days_in_Month {
  my ($y, $m) = @_;
  return ('x', 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)[$m]
    unless $m == 2;
  return _isLeapYear($y) ? 29 : 28;
}

sub GetPrevDate {
  my $date = shift;
  my($pmon, $pday, $pyear) = split(/-/, $date);
  if($pday == 1) {
    if($pmon == 1) {
      $pyear -= 1;
      $pmon = 12;
    } else {
      $pmon -= 1;
    }
    $pday = &Days_in_Month($pyear, $pmon);
  } else {
    $pday -= 1;
  }
  return "$pmon-$pday-$pyear";
}

sub GetNextDate {
  my $date = shift;
  my($nmon, $nday, $nyear) = split(/-/, $date);
  $ndim = &Days_in_Month($nyear, $nmon);
  if($nday == $ndim) {
    if($nmon == 12) {
      $nyear += 1;
      $nmon = 1;
    } else {
      $nmon += 1;
    }
    $nday = 1;
  } else {
    $nday += 1;
  }
  return "$nmon-$nday-$nyear";
}

sub date {
  local($time, $format) = @_;
  local($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = gmtime($time);
  
  $sec  = "0$sec" if ($sec < 10);
  $min  = "0$min" if ($min < 10);
  $hour = "0$hour" if ($hour < 10);
  $mon  = "0$mon" if ($mon < 10);
  $mday = "0$mday" if ($mday < 10);
  my @months = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul",
                "Aug", "Sep", "Oct", "Nov", "Dec");
  
  $month = $months[$mon];
  $year -= 100 if($year > 99);
  $year = "0$year" if ($year < 10);
  return "$mday-$month-$year $hour\:$min\:$sec GMT";
}

1;
